Imports System.IO

Module Module1

    Sub Main()

        Dim strFileName As String = My.Application.Info.DirectoryPath _
                          & "\empout_pipe.txt"
        Dim objFS As New FileStream(strFileName, FileMode.Create, FileAccess.Write)
        Dim objSW As New StreamWriter(objFS)

        Dim strEmpName As String
        Dim intDeptNbr As Integer
        Dim strJobTitle As String
        Dim dtmHireDate As Date
        Dim sngHrlyRate As Single

        ' Set up an "input loop" to prompt the user for data ...

        ' "Priming" input:
        strEmpName = GetEmployeeName()

        ' The loop will continue until the user enters a zero-length string for the 
        ' employee name ...
        Do Until strEmpName = ""

            ' Prompt the user for each field ...
            intDeptNbr = GetDepartment()
            strJobTitle = GetJobTitle()
            dtmHireDate = GetHireDate()
            sngHrlyRate = GetHourlyRate()

            ' Write out the record to the file ...
            objSW.WriteLine(strEmpName & "|" & _
                            intDeptNbr.ToString & "|" & _
                            strJobTitle & "|" & _
                            Format(dtmHireDate, "M/d/yyyy") & "|" & _
                            sngHrlyRate.ToString)

            Console.WriteLine("Record was written to the output file.")
            Console.WriteLine("")

            ' Start a new record by prompting for the employee name ...
            strEmpName = GetEmployeeName()
        Loop

        objSW.Close()

        Console.WriteLine("")
        Console.WriteLine("File creation complete. Press Enter to close this window.")
        Console.ReadLine()

    End Sub

    Private Function GetEmployeeName() As String

        Dim strTest As String
        Dim blnValidInput As Boolean

        Do
            Console.Write("Enter Employee Name (1-20 characters / nothing to quit): ")
            strTest = Console.ReadLine()
            strTest.Trim()
            blnValidInput = True
            If strTest.Length > 20 Then
                blnValidInput = False
                Console.WriteLine("Invalid employee name.")
            End If
        Loop Until blnValidInput

        Return (strTest)

    End Function

    Private Function GetDepartment() As Integer

        Dim strTest As String
        Dim blnValidInput As Boolean
        Dim intX As Integer

        Do
            Console.Write("Enter Dept (1 to 4 digits): ")
            strTest = Console.ReadLine()
            blnValidInput = True
            If strTest.Length < 1 Or strTest.Length > 4 Then
                blnValidInput = False
            Else
                For intX = 0 To (strTest.Length - 1)
                    If Not (Char.IsDigit(strTest.Chars(intX))) Then
                        blnValidInput = False
                        Exit For
                    End If
                Next
            End If
            If Not blnValidInput Then
                Console.WriteLine("Invalid department number.")
            End If
        Loop Until blnValidInput

        Return (CInt(strTest))

    End Function

    Private Function GetJobTitle() As String

        Dim strTest As String
        Dim blnValidInput As Boolean

        Do
            Console.Write("Enter Job Title (1 to 21 characters): ")
            strTest = Console.ReadLine()
            blnValidInput = True
            If strTest.Length < 1 Or strTest.Length > 21 Then
                Console.WriteLine("Invalid job title.")
                blnValidInput = False
            End If
        Loop Until blnValidInput

        Return (strTest)

    End Function

    Private Function GetHireDate() As Date

        Dim strTest As String
        Dim blnValidInput As Boolean

        Do
            Console.Write("Enter Hire Date (month/day/year): ")
            strTest = Console.ReadLine()
            blnValidInput = True
            If Not IsDate(strTest) Then
                Console.WriteLine("Invalid hire date.")
                blnValidInput = False
            End If
        Loop Until blnValidInput

        Return (CDate(strTest))

    End Function

    Private Function GetHourlyRate() As Single

        Dim strTest As String
        Dim blnValidInput As Boolean

        Do
            Console.Write("Enter Hourly Rate (0 to 99.99): ")
            strTest = Console.ReadLine()
            blnValidInput = True
            If Not IsNumeric(strTest) Then
                blnValidInput = False
            ElseIf Val(strTest) < 0 Or Val(strTest) > 99.99 Then
                blnValidInput = False
            End If
            If Not blnValidInput Then
                Console.WriteLine("Invalid hourly rate.")
            End If
        Loop Until blnValidInput

        Return (CSng(strTest))

    End Function

End Module
